"use strict"; function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }require('../chunk-XDHMFIVF.cjs');
require('../chunk-XXEOX3J7.cjs');
require('../chunk-SDJIWERF.cjs');
require('../chunk-WQJQH5HJ.cjs');
require('../chunk-62FVEJL6.cjs');
require('../chunk-GAYOTONV.cjs');
require('../chunk-MOA6L574.cjs');
require('../chunk-RUOHVTBN.cjs');
require('../chunk-OX44225N.cjs');
require('../chunk-QLGR2XSS.cjs');
require('../chunk-QZHRO76T.cjs');
require('../chunk-OA4HK3MT.cjs');
require('../chunk-MKPXOLNJ.cjs');



var _chunk2X2KSRJHcjs = require('../chunk-2X2KSRJH.cjs');
require('../chunk-4B2XCWGL.cjs');
require('../chunk-5CIFX7O6.cjs');
require('../chunk-RQERABKF.cjs');


var _chunkMC7TILQ6cjs = require('../chunk-MC7TILQ6.cjs');
require('../chunk-77UGQWYH.cjs');
require('../chunk-CE2FX4SJ.cjs');
require('../chunk-BBX7CCGY.cjs');
require('../chunk-UKD65B23.cjs');
require('../chunk-DCCSUOSM.cjs');
require('../chunk-J42M6DF3.cjs');
require('../chunk-N46W55MH.cjs');
require('../chunk-L646RZQB.cjs');
require('../chunk-ZYPCVNSG.cjs');
require('../chunk-XV5FJ2SJ.cjs');
require('../chunk-A4VFMLAN.cjs');
require('../chunk-R7WMTFSS.cjs');
require('../chunk-DRTH56G4.cjs');
require('../chunk-RKOTNV3K.cjs');
require('../chunk-XWE2OTGL.cjs');
require('../chunk-KTC5RW57.cjs');
require('../chunk-GU6AYGWK.cjs');
require('../chunk-SNRM7OTJ.cjs');
require('../chunk-ZGKV237Z.cjs');
require('../chunk-7WFR6WZW.cjs');
require('../chunk-N7OUNPMM.cjs');
require('../chunk-MPD2DJAD.cjs');
require('../chunk-YELWQAMG.cjs');
require('../chunk-USVMO7UT.cjs');
require('../chunk-TNS27NHR.cjs');
require('../chunk-FEYF6QXS.cjs');
require('../chunk-HMHMDCOK.cjs');
require('../chunk-3SM3C7HY.cjs');
require('../chunk-EE5CB3R7.cjs');


var _chunkQYCE2TUJcjs = require('../chunk-QYCE2TUJ.cjs');
require('../chunk-5KIDARFB.cjs');
require('../chunk-CEXYDYSH.cjs');
require('../chunk-PJXRDQ2A.cjs');
require('../chunk-6T6PI6XG.cjs');
require('../chunk-XDY4SRCL.cjs');
require('../chunk-FYLSPYV2.cjs');
require('../chunk-YKRFYR2Q.cjs');
require('../chunk-QU2LM4AI.cjs');
require('../chunk-BMRI2X66.cjs');
require('../chunk-66YRDFQP.cjs');
require('../chunk-7FPSHSSO.cjs');

// src/common/dispose-defer.spec.ts
var log = _chunkMC7TILQ6cjs.DefaultLogger.call(void 0, "dispose-test");
describe("dispose", () => {
  it("should dispose correctly", async () => {
    const disposeCalls = [];
    const dispose = _chunk2X2KSRJHcjs.useDispose.call(void 0, "a");
    const y = dispose.track({
      dispose() {
        disposeCalls.push(1);
      }
    });
    dispose.track(() => {
      disposeCalls.push(2);
    });
    const x = {
      async dispose() {
        disposeCalls.push(3);
      }
    };
    dispose.track(x);
    dispose.track();
    dispose.track(async () => {
      disposeCalls.push(4);
    });
    expect(disposeCalls).toEqual([]);
    expect(dispose.getSize()).toEqual(4);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3]);
    expect(dispose.getSize()).toEqual(3);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3]);
    expect(dispose.getSize()).toEqual(3);
    _optionalChain([y, 'optionalCall', _ => _()]);
    _optionalChain([y, 'optionalCall', _2 => _2()]);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3, 1]);
    expect(dispose.getSize()).toEqual(2);
    await dispose.dispose();
    expect(disposeCalls).toEqual([3, 1, 4, 2]);
    expect(dispose.getSize()).toEqual(0);
    await dispose();
    expect(disposeCalls).toEqual([3, 1, 4, 2]);
    expect(dispose.getSize()).toEqual(0);
  });
  it("should be a fancy dispose itself", () => {
    let x = 1;
    class Some {
      constructor() {
        this.dispose = _chunk2X2KSRJHcjs.useDispose.call(void 0, log);
        this.dispose.track(() => {
          x = 2;
        });
      }
    }
    const obj = new Some();
    expect(x).toBe(1);
    void obj.dispose();
    expect(x).toBe(2);
  });
  it("should defer lifo", async () => {
    const stack = [];
    const defer = _chunk2X2KSRJHcjs.useDefer.call(void 0, { mode: "lifo" });
    defer.add(() => stack.push("a"));
    defer.add(() => stack.push("b"));
    defer.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    void defer(true);
    expect(stack).toEqual(["c", "b", "a"]);
  });
  it("should defer fifo", async () => {
    const stack = [];
    const defer = _chunk2X2KSRJHcjs.useDefer.call(void 0, { mode: "fifo" });
    defer.add(() => stack.push("a"));
    defer.add(async () => stack.push("b"));
    defer.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    await defer();
    expect(stack).toEqual(["a", "b", "c"]);
  });
  it("should dispose sync", async () => {
    const stack = [];
    const dispose = _chunk2X2KSRJHcjs.useDispose.call(void 0, );
    dispose.add(() => stack.push("a"));
    dispose.add(() => stack.push("b"));
    dispose.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    await dispose(true);
    expect(stack).toEqual(["c", "b", "a"]);
  });
  it("should dispose sync 2", async () => {
    const stack = [];
    const dispose = _chunk2X2KSRJHcjs.useDispose.call(void 0, );
    dispose.add(() => stack.push("a"));
    dispose.add(() => stack.push("b"));
    dispose.add(async () => {
      await _chunkQYCE2TUJcjs.sleep.call(void 0, 1);
      stack.push("c");
    });
    expect(stack).toEqual([]);
    expect(dispose.sync).toThrowError();
  });
});
//# sourceMappingURL=dispose-defer.spec.cjs.map