import {
  useMessageHub
} from "../../chunk-NUUT5WGY.js";
import {
  CryptoEncoder
} from "../../chunk-AJ3WFXQE.js";
import {
  createLocalChannelPair
} from "../../chunk-AP2LHZQJ.js";
import "../../chunk-TECA6FV3.js";
import "../../chunk-MY57YSRI.js";
import "../../chunk-RLHKRW4I.js";
import "../../chunk-UV5YY7RE.js";
import "../../chunk-TSCDX4AS.js";
import "../../chunk-D6B6MYVG.js";
import "../../chunk-PAMCEPLQ.js";
import "../../chunk-JSFYTABJ.js";
import "../../chunk-7ITBV6UM.js";
import "../../chunk-RZKR2WPX.js";
import {
  deriveKeyPbkdf2,
  randomUint8Array
} from "../../chunk-RG6OSZW5.js";
import "../../chunk-MIZOLME5.js";
import "../../chunk-XGHGEMIC.js";
import "../../chunk-YX6CL4KH.js";
import "../../chunk-I45WP5PM.js";
import "../../chunk-ZFRTRIT4.js";
import "../../chunk-CFICINSP.js";
import "../../chunk-6C3JJJOL.js";
import "../../chunk-5Y3HYG6B.js";
import "../../chunk-T7PU5CTZ.js";
import "../../chunk-XSB2WAW2.js";
import "../../chunk-X2DIUKLP.js";
import "../../chunk-NYCGHEIN.js";
import "../../chunk-AS5LR4AI.js";
import "../../chunk-KQSQJAHU.js";
import "../../chunk-JC22THP7.js";
import "../../chunk-2HWPZ6ZE.js";
import "../../chunk-XOOIUMF2.js";
import "../../chunk-73CVRDI7.js";
import "../../chunk-FL5CT6MC.js";
import "../../chunk-HLRQ5H3N.js";
import "../../chunk-M6LJR6SZ.js";
import "../../chunk-NXVGWT4R.js";
import "../../chunk-DGP32WEQ.js";
import "../../chunk-O4U55KGC.js";
import "../../chunk-4XPO57AQ.js";
import "../../chunk-MVRB7Y7X.js";
import "../../chunk-FSDCRQB3.js";
import "../../chunk-MRFHKDNG.js";
import "../../chunk-AEBHR4XF.js";
import "../../chunk-IZT6OHMS.js";
import "../../chunk-GY34N3KU.js";
import "../../chunk-NS4INNCL.js";
import "../../chunk-TYWNSO7K.js";
import "../../chunk-ZMFW3O35.js";
import "../../chunk-R6KULE2F.js";
import "../../chunk-7NSVDPHN.js";
import "../../chunk-VVNSHVPQ.js";
import "../../chunk-6GHO7LQW.js";

// src/common/msg/messages.spec.ts
describe("messages", () => {
  it("should show the magic of proxies ", async () => {
    const p = new Proxy({}, {
      get(_target, _name) {
        return (...args) => {
          return args[0] ?? 0;
        };
      }
    });
    expect(await p.ping(await p.ping(2))).toBe(2);
  });
  it("should do hub thing", async () => {
    const key = await deriveKeyPbkdf2(randomUint8Array(20));
    const encoder = new CryptoEncoder(key);
    const [clientChannel, serverChannel] = createLocalChannelPair();
    const serverHub = useMessageHub({ channel: serverChannel, encoder });
    serverHub.listen({
      async ping(value) {
        expect(value).toBe(2);
        return value;
      }
    });
    serverHub.listen({
      async aping(value) {
        return new Promise((resolve) => setTimeout(() => resolve(value), 500));
      }
    });
    const clientHub = useMessageHub({ channel: clientChannel, encoder });
    const client = clientHub.send();
    const x = await client.aping(1);
    const y = await client.aping("H\xE4llo W\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}rld");
    expect(x).toBe(1);
    expect(y).toBe("H\xE4llo W\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}rld");
    await client.ping(2);
  });
});
//# sourceMappingURL=messages.spec.js.map