import {
  getSourceLocation,
  getStackLlocationList
} from "../../chunk-UE7BSADT.js";
import "../../chunk-HMRSQHLY.js";
import "../../chunk-UMUHNSGZ.js";
import "../../chunk-SRT6T6F5.js";
import "../../chunk-RMPE2GT3.js";
import "../../chunk-MO24G7VK.js";
import "../../chunk-QQSABUQG.js";
import "../../chunk-RNL46FQ3.js";
import "../../chunk-MWUFUBY5.js";
import "../../chunk-GKKLBSFA.js";
import "../../chunk-264HKVNG.js";
import "../../chunk-YP5GPYKL.js";
import "../../chunk-LKHGPAZI.js";
import "../../chunk-FLFB2K34.js";
import "../../chunk-HST4VI64.js";
import "../../chunk-A7SUGWC3.js";
import "../../chunk-RO734M2N.js";
import "../../chunk-K6VSSZK7.js";
import "../../chunk-MYPACQAF.js";
import "../../chunk-W4PZPEDX.js";
import "../../chunk-IQFZHKL7.js";
import "../../chunk-NUUT5WGY.js";
import "../../chunk-AJ3WFXQE.js";
import "../../chunk-BUMAFR52.js";
import "../../chunk-AP2LHZQJ.js";
import "../../chunk-TECA6FV3.js";
import "../../chunk-UH2XTXP7.js";
import "../../chunk-MPAXUMZ5.js";
import "../../chunk-PJDBG5VS.js";
import "../../chunk-MY57YSRI.js";
import "../../chunk-RLHKRW4I.js";
import "../../chunk-UV5YY7RE.js";
import "../../chunk-TSCDX4AS.js";
import "../../chunk-D6B6MYVG.js";
import "../../chunk-PAMCEPLQ.js";
import "../../chunk-JSFYTABJ.js";
import "../../chunk-7ITBV6UM.js";
import "../../chunk-RZKR2WPX.js";
import "../../chunk-RG6OSZW5.js";
import "../../chunk-MIZOLME5.js";
import "../../chunk-XGHGEMIC.js";
import "../../chunk-YX6CL4KH.js";
import "../../chunk-I45WP5PM.js";
import "../../chunk-ZFRTRIT4.js";
import "../../chunk-CFICINSP.js";
import "../../chunk-6C3JJJOL.js";
import "../../chunk-5Y3HYG6B.js";
import "../../chunk-T7PU5CTZ.js";
import "../../chunk-XSB2WAW2.js";
import "../../chunk-X2DIUKLP.js";
import "../../chunk-NYCGHEIN.js";
import "../../chunk-AS5LR4AI.js";
import "../../chunk-KQSQJAHU.js";
import "../../chunk-JC22THP7.js";
import "../../chunk-2HWPZ6ZE.js";
import "../../chunk-XOOIUMF2.js";
import "../../chunk-73CVRDI7.js";
import "../../chunk-FL5CT6MC.js";
import "../../chunk-HLRQ5H3N.js";
import "../../chunk-M6LJR6SZ.js";
import "../../chunk-NXVGWT4R.js";
import "../../chunk-DGP32WEQ.js";
import "../../chunk-O4U55KGC.js";
import "../../chunk-4XPO57AQ.js";
import "../../chunk-MVRB7Y7X.js";
import "../../chunk-FSDCRQB3.js";
import "../../chunk-MRFHKDNG.js";
import "../../chunk-AEBHR4XF.js";
import "../../chunk-IZT6OHMS.js";
import "../../chunk-GY34N3KU.js";
import "../../chunk-NS4INNCL.js";
import "../../chunk-TYWNSO7K.js";
import "../../chunk-ZMFW3O35.js";
import "../../chunk-R6KULE2F.js";
import "../../chunk-7NSVDPHN.js";
import "../../chunk-VVNSHVPQ.js";
import "../../chunk-6GHO7LQW.js";

// src/node/log/log-util.spec.ts
describe("log-util", () => {
  it("should find correct source file line", () => {
    const source = getSourceLocation(1, true);
    expect(source.startsWith("src/node/log/log-util.spec.ts:")).toBe(true);
  });
  it("should parse stack", () => {
    const sample = `
    at getSourceLocation (file:///Users/dirk/work/public/zeed/dist/esm/node/log-util.js:13:17)
    at file:///Users/dirk/work/public/zeed/dist/esm/node/log-node.js:105:26
    at /Users/dirk/work/public/zeed/dist/esm/node/log-node.js:105:26
    at emit (file:///Users/dirk/work/public/zeed/dist/esm/common/log.js:32:33)
    at Function.LoggerBaseFactory.log.info (file:///Users/dirk/work/public/zeed/dist/esm/common/log.js:55:13)
    at file:///Users/dirk/work/public/zeed/demos/logging/index.js:37:5
    at ModuleJob.run (node:internal/modules/esm/module_job:183:25)
    at async Loader.import (node:internal/modules/esm/loader:178:24)
    at async Object.loadESM (node:internal/process/esm_loader:68:5)
    at async handleMainPromise (node:internal/modules/run_main:63:12)
`;
    expect(getStackLlocationList(sample)).toEqual([
      "/Users/dirk/work/public/zeed/dist/esm/node/log-util.js:13:17",
      "/Users/dirk/work/public/zeed/dist/esm/node/log-node.js:105:26",
      "/Users/dirk/work/public/zeed/dist/esm/node/log-node.js:105:26",
      "/Users/dirk/work/public/zeed/dist/esm/common/log.js:32:33",
      "/Users/dirk/work/public/zeed/dist/esm/common/log.js:55:13",
      "/Users/dirk/work/public/zeed/demos/logging/index.js:37:5",
      "node:internal/modules/esm/module_job:183:25",
      "node:internal/modules/esm/loader:178:24",
      "node:internal/process/esm_loader:68:5",
      "node:internal/modules/run_main:63:12"
    ]);
  });
});
//# sourceMappingURL=log-util.spec.js.map